/*
 * Block tree functions
 *
 * Copyright (c) 2011-2012, Joachim Metz <jbmetz@users.sourceforge.net>
 *
 * Refer to AUTHORS for acknowledgements.
 *
 * This software is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this software.  If not, see <http://www.gnu.org/licenses/>.
 */

#if !defined( _LIBVSHADOW_BLOCK_TREE_H )
#define _LIBVSHADOW_PAGE_BLOCK_H

#include <common.h>
#include <types.h>

#include "libvshadow_block_descriptor.h"
#include "libvshadow_btree_type.h"
#include "libvshadow_libcerror.h"

#if defined( __cplusplus )
extern "C" {
#endif

int libvshadow_block_tree_node_get_descriptor_by_original_offset(
     libvshadow_tree_node_t *node,
     off64_t original_offset,
     libvshadow_block_descriptor_t **block_descriptor,
     libcerror_error_t **error );

int libvshadow_block_tree_node_get_descriptor_by_relative_offset(
     libvshadow_tree_node_t *node,
     off64_t relative_offset,
     libvshadow_block_descriptor_t **block_descriptor,
     libcerror_error_t **error );

int libvshadow_block_tree_get_range_by_original_offset(
     libvshadow_btree_t *block_tree,
     off64_t original_offset,
     off64_t *block_offset,
     size_t *block_size,
     uint32_t *block_flags,
     libcerror_error_t **error );

int libvshadow_block_tree_insert(
     libvshadow_btree_t *forward_block_tree,
     libvshadow_btree_t *reverse_block_tree,
     libvshadow_block_descriptor_t *block_descriptor,
     libcerror_error_t **error );

#if defined( __cplusplus )
}
#endif

#endif

